"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class HTMLAttributePlugin {
    constructor(options = { script: {}, style: {} }) {
        this.options = options;
    }
    apply(compiler) {
        const options = this.options;
        compiler.hooks.compilation.tap('HTMLAttributePlugin', (compilation) => {
            // @ts-ignore
            compilation.hooks.htmlWebpackPluginAlterAssetTags.tapAsync('HTMLAttributePlugin', (data, callback) => {
                data.assetTags.scripts = data.assetTags.scripts.map((script) => {
                    return Object.assign(Object.assign({}, script), { attributes: Object.assign(Object.assign({}, script.attributes), options.script) });
                });
                data.assetTags.styles = data.assetTags.styles.map((style) => {
                    return Object.assign(Object.assign({}, style), { attributes: Object.assign(Object.assign({}, style.attributes), options.style) });
                });
                callback(null, data);
            });
        });
    }
}
exports.default = HTMLAttributePlugin;
